Index: /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/iom_rstdimg.f90
===================================================================
--- /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/iom_rstdimg.f90	(revision 5212)
+++ /branches/2015/dev_r5021_UKMO1_CICE_coupling/NEMOGCM/TOOLS/SIREN/src/iom_rstdimg.f90	(revision 5213)
@@ -10,66 +10,73 @@
 !>
 !> @details
-!>
 !>    to open dimg file (create file structure):<br/>
+!> @code
 !>    CALL iom_rstdimg_open(td_file)
+!> @endcode
 !>       - td_file is file structure (see file.f90)
 !>
 !>    to write in dimg file:<br/>
+!> @code
 !>    CALL  iom_rstdimg_write_file(td_file)
+!> @endcode
 !>
 !>    to close dimg file:<br/>
+!> @code
 !>    CALL iom_rstdimg_close(tl_file)
+!> @endcode
 !>
 !>    to read one dimension in dimg file:<br/>
-!>    tl_dim = iom_rstdimg_read_dim(tl_file, id_dimid)<br/>
-!>    or<br/>
+!> @code
+!>    tl_dim = iom_rstdimg_read_dim(tl_file, id_dimid)
+!> @endcode
+!>    or
+!> @code
 !>    tl_dim = iom_rstdimg_read_dim(tl_file, cd_name)
+!> @endcode
 !>       - id_dimid is dimension id<br/>
 !>       - cd_name is dimension name
 !>
-!>    to read one global attribute in dimg file:<br/>
-!>    tl_att = iom_rstdimg_read_att(tl_file, id_varid, id_attid)<br/>
-!>    or<br/>
-!>    tl_att = iom_rstdimg_read_att(tl_file, id_varid, cd_name)
-!>       - id_varid is variable id
-!>       - id_attid is attribute id<br/>
-!>       - cd_name is attribute name
-!>  
 !>    to read one variable in dimg file:<br/>
-!>    tl_var = iom_rstdimg_read_var(td_file, id_varid, [id_start, id_count])<br/>
-!>    or<br/>
-!>    tl_var = iom_rstdimg_read_var(td_file, cd_name, [id_start, [id_count,]] [cd_stdname])
+!> @code
+!>    tl_var = iom_rstdimg_read_var(td_file, id_varid, [id_start, id_count])
+!> @endcode
+!>    or
+!> @code
+!>    tl_var = iom_rstdimg_read_var(td_file, cd_name, [id_start, [id_count]])
+!> @endcode
 !>       - id_varid is variabale id
-!>       - cd_name is variabale name
-!>       - id_start is a integer(4) 1D table of index from which the data 
-!>          values will be read (optional)
-!>       - id_count is a integer(4) 1D table of the number of indices selected
-!>          along each dimension (optional)
-!>       - cd_stdname is variable standard name (optional)
+!>       - cd_name is variabale name or standard name
+!>       - id_start is a integer(4) 1D array of index from which the data 
+!>          values will be read [optional]
+!>       - id_count is a integer(4) 1D array of the number of indices selected
+!>          along each dimension [optional]
+!>
+!>    to get sub domain decomppistion in a dimg file:<br/>
+!> @code
+!>    CALL iom_rstdimg_get_mpp(td_file)
+!> @endcode
 !>
 !> @author
 !> J.Paul
 ! REVISION HISTORY:
-!> @date Nov, 2013 - Initial Version
-!
-!> @param MyModule_type : brief_description
+!> @date November, 2013 - Initial Version
 !
 !> @note Software governed by the CeCILL licence     (NEMOGCM/NEMO_CeCILL.txt)
-!
-!> @todo
 !----------------------------------------------------------------------
 MODULE iom_rstdimg
    USE netcdf                          ! nf90 library
+   USE global                          ! global parameter
    USE kind                            ! F90 kind parameter
    USE fct                             ! basic useful function
-   USE logger                             ! log file manager
+   USE logger                          ! log file manager
    USE att                             ! attribute manager
    USE dim                             ! dimension manager
    USE var                             ! variable manager
    USE file                            ! file manager
-   USE dom                             ! domain manager
    IMPLICIT NONE
-   PRIVATE
    ! NOTE_avoid_public_variables_if_possible
+
+   ! type and variable
+   PRIVATE ::  im_vnl !< variable name length 
 
    ! function and subroutine
@@ -78,27 +85,24 @@
    PUBLIC :: iom_rstdimg_read_dim    !< read one dimension in an opened dimg file, return variable structure
    PUBLIC :: iom_rstdimg_read_var    !< read one variable  in an opened dimg file, return dimension structure
-   PUBLIC :: iom_rstdimg_fill_var    !< fill variable value in an opened dimg file
    PUBLIC :: iom_rstdimg_write_file  !< write file structure contents in an opened dimg file
    PUBLIC :: iom_rstdimg_get_mpp     !< get sub domain decomppistion in a dimg file
 
-   PRIVATE :: iom_rstdimg__get_info       !< get global information in an opened dimg file
-   PRIVATE :: iom_rstdimg__get_file_var   !< read information about variable on an opened dimg file.
-   PRIVATE :: iom_rstdimg__get_file_var_0d !< put information about scalar variable in file structure
-   PRIVATE :: iom_rstdimg__get_file_var_1d !< put information about variable 1D in file structure
-   PRIVATE :: iom_rstdimg__get_file_var_2d !< put information about variable 2D in file structure
-   PRIVATE :: iom_rstdimg__get_file_var_3d !< put information about variable 3D in file structure
-   PRIVATE :: iom_rstdimg__read_dim_id    !< read dimension structure in an opened dimg file, given variable id.
-   PRIVATE :: iom_rstdimg__read_dim_name  !< read dimension structure in an opened dimg file, given variable name or standard name.
-   PRIVATE :: iom_rstdimg__read_var_id    !< read variable value in an opened dimg file, given variable id.
-   PRIVATE :: iom_rstdimg__read_var_name  !< read variable value in an opened dimg file, given variable name or standard name.
-   PRIVATE :: iom_rstdimg__read_var_value !< read variable value in an opened dimg file, for variable 1,2,3d
-   PRIVATE :: iom_rstdimg__write_header   !< write header in an opened dimg file
-   PRIVATE :: iom_rstdimg__write_var      !< write variables in an opened dimg file 
-   PRIVATE :: iom_rstdimg__fill_var_id    !< fill variable value in an opened dimg file, given variable id
-   PRIVATE :: iom_rstdimg__fill_var_name  !< fill variable value in an opened dimg file, given variable name
-   PRIVATE :: iom_rstdimg__fill_var_all   !< fill all variable value in an opened dimg file
+   PRIVATE :: iom_rstdimg__get_info        ! get global information in an opened dimg file
+   PRIVATE :: iom_rstdimg__get_file_var    ! read information about variable on an opened dimg file.
+   PRIVATE :: iom_rstdimg__get_file_var_0d ! put information about scalar variable in file structure
+   PRIVATE :: iom_rstdimg__get_file_var_1d ! put information about variable 1D in file structure
+   PRIVATE :: iom_rstdimg__get_file_var_2d ! put information about variable 2D in file structure
+   PRIVATE :: iom_rstdimg__get_file_var_3d ! put information about variable 3D in file structure
+   PRIVATE :: iom_rstdimg__read_dim_id     ! read dimension structure in an opened dimg file, given variable id.
+   PRIVATE :: iom_rstdimg__read_dim_name   ! read dimension structure in an opened dimg file, given variable name or standard name.
+   PRIVATE :: iom_rstdimg__read_var_id     ! read variable value in an opened dimg file, given variable id.
+   PRIVATE :: iom_rstdimg__read_var_name   ! read variable value in an opened dimg file, given variable name or standard name.
+   PRIVATE :: iom_rstdimg__read_var_value  ! read variable value in an opened dimg file, for variable 1,2,3d
+   PRIVATE :: iom_rstdimg__get_rec         ! compute record number before writing file
+   PRIVATE :: iom_rstdimg__write_header    ! write header in an opened dimg file
+   PRIVATE :: iom_rstdimg__write_var       ! write variables in an opened dimg file 
 
    ! module variable
-   INTEGER(i4), PARAMETER :: ip_vnl = 32 ! variable name length
+   INTEGER(i4), PARAMETER :: im_vnl = 32 ! variable name length
 
    INTERFACE iom_rstdimg_read_dim
@@ -112,13 +116,8 @@
    END INTERFACE iom_rstdimg_read_var
 
-   INTERFACE iom_rstdimg_fill_var
-      MODULE PROCEDURE iom_rstdimg__fill_var_id
-      MODULE PROCEDURE iom_rstdimg__fill_var_name
-      MODULE PROCEDURE iom_rstdimg__fill_var_all
-   END INTERFACE iom_rstdimg_fill_var   
-
 CONTAINS
    !-------------------------------------------------------------------
-   !> @brief This subroutine open a dimg file in read or write mode<br/>
+   !> @brief This subroutine open a dimg file in read or write mode.
+   !> @details
    !> if try to open a file in write mode that did not exist, create it.<br/>
    !> if file already exist, get information about:
@@ -128,12 +127,12 @@
    !> - the ID of the unlimited dimension
    !> - the file format
-   !> and finally read dimensions.
+   !> Finally it read dimensions, and 'longitude' variable to compute East-West
+   !> overlap.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_rstdimg_open(td_file)
       IMPLICIT NONE
@@ -146,6 +145,4 @@
 
       INTEGER(i4)       :: il_status
-      
-      TYPE(TVAR)        :: tl_lon
       !----------------------------------------------------------------
 
@@ -180,5 +177,4 @@
             ENDIF
 
-
          ENDIF
 
@@ -224,5 +220,4 @@
             ENDIF
 
-
             IF( .NOT. td_file%l_wrt )THEN
 
@@ -240,5 +235,8 @@
                CALL fct_err(il_status)
                IF( il_status /= 0 )THEN
-                  CALL logger_error("OPEN: file "//TRIM(td_file%c_name)&
+                  CALL logger_debug("IOM RSTDIMG OPEN: open staus "//&
+                  &  TRIM(fct_str(il_status)))
+                  CALL logger_fatal("IOM RSTDIMG OPEN: file "//&
+                  &  TRIM(td_file%c_name)&
                   &  //" with record length "//TRIM(fct_str(td_file%i_recl)))
                ENDIF               
@@ -260,5 +258,8 @@
                CALL fct_err(il_status)
                IF( il_status /= 0 )THEN
-                  CALL logger_error("OPEN: file "//TRIM(td_file%c_name))
+                  CALL logger_debug("IOM RSTDIMG OPEN: open staus "//&
+                  &  TRIM(fct_str(il_status)))
+                  CALL logger_error("IOM RSTDIMG  OPEN: file "//&
+                  & TRIM(td_file%c_name))
                ENDIF        
 
@@ -274,12 +275,4 @@
             CALL iom_rstdimg__get_file_var(td_file)
 
-            ! get ew overlap
-            tl_lon=iom_rstdimg_read_var(td_file,'longitude')
-            td_file%i_ew=dom_get_ew_overlap(tl_lon)
-            WHERE( td_file%t_var(:)%t_dim(1)%l_use )
-               td_file%t_var(:)%i_ew=td_file%i_ew
-            ENDWHERE
-            CALL var_clean(tl_lon) 
-
          ENDIF
 
@@ -287,14 +280,12 @@
 
    END SUBROUTINE iom_rstdimg_open
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine close dimg file
+   !-------------------------------------------------------------------
+   !> @brief This subroutine close dimg file.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_rstdimg_close(td_file)
       IMPLICIT NONE
@@ -327,21 +318,18 @@
 
    END SUBROUTINE iom_rstdimg_close
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine get global information in an opened dimg 
-   !> file.<br/>
+   !> file.
    !> @details
    !> It gets the number of variables, the  domain decompistion, 
-   !> the record of the header infos.<br/>
+   !> the record of the header.<br/>
    !> It read dimensions, and add it to dimension structure inside 
    !> file structure.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @return file structure completed 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_rstdimg__get_info(td_file)
       IMPLICIT NONE
@@ -360,5 +348,5 @@
 
       CALL logger_debug( &
-      &  " GET INFO: about dimg file "//TRIM(td_file%c_name))
+      &  " IOM RSTDIMG GET INFO: about dimg file "//TRIM(td_file%c_name))
 
       ! read first record 
@@ -370,9 +358,8 @@
       CALL fct_err(il_status)
       IF( il_status /= 0 )THEN
-         CALL logger_error("GET INFO: read first line of "//TRIM(td_file%c_name))
-      ENDIF
-
-      CALL logger_trace( &
-      &  " GET INFO: about dimg file "//TRIM(td_file%c_name))
+         CALL logger_debug(" READ status: "//TRIM(fct_str(il_status)))
+         CALL logger_fatal("IOM RSTDIMG GET INFO: read first line of "//&
+         &  TRIM(td_file%c_name))
+      ENDIF
 
       td_file%c_type='dimg'
@@ -380,9 +367,9 @@
       ! add dimension to file structure
       tl_dim=dim_init('X', il_nx)
-      CALL file_add_dim(td_file, tl_dim)
+      CALL file_move_dim(td_file, tl_dim)
       tl_dim=dim_init('Y', il_ny)
-      CALL file_add_dim(td_file, tl_dim)
+      CALL file_move_dim(td_file, tl_dim)
       tl_dim=dim_init('Z', il_nz)
-      CALL file_add_dim(td_file, tl_dim)
+      CALL file_move_dim(td_file, tl_dim)
 
       ! reorder dimension to ('x','y','z','t')
@@ -401,17 +388,14 @@
 
    END SUBROUTINE iom_rstdimg__get_info
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine get sub domain decomposition in a dimg file.<br/>
+   !-------------------------------------------------------------------
+   !> @brief This subroutine get sub domain decomposition in a dimg file.
    !> @details
    !> domain decomposition informations are saved in attributes.
    !>
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @return mpp structure 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_rstdimg_get_mpp(td_file)
       IMPLICIT NONE
@@ -440,5 +424,6 @@
       !----------------------------------------------------------------
 
-      CALL logger_trace( " GET MPP: dimg file "//TRIM(td_file%c_name))
+      CALL logger_debug( " IOM RSTDIMG GET MPP: dimg file "//&
+      &  TRIM(td_file%c_name))
 
       ! read first record 
@@ -453,22 +438,25 @@
       CALL fct_err(il_status)
       IF( il_status /= 0 )THEN
-         CALL logger_error("GET MPP: read first line of "//TRIM(td_file%c_name))
+         CALL logger_debug(" IOM RSTDIMG GET MPP: read status: "//&
+         &  TRIM(fct_str(il_status)))
+         CALL logger_error(" IOM RSTDIMG GET MPP: read first line of "//&
+         &  TRIM(td_file%c_name))
       ENDIF
 
       ! create attributes to save mpp value
       tl_att=att_init( "DOMAIN_number_total", il_nproc)
-      CALL file_add_att(td_file, tl_att)
+      CALL file_move_att(td_file, tl_att)
 
       tl_att=att_init( "DOMAIN_I_number_total", il_niproc)
-      CALL file_add_att(td_file, tl_att)
+      CALL file_move_att(td_file, tl_att)
 
       tl_att=att_init( "DOMAIN_J_number_total", il_njproc)
-      CALL file_add_att(td_file, tl_att)
+      CALL file_move_att(td_file, tl_att)
 
       tl_att=att_init( "DOMAIN_number", il_area)
-      CALL file_add_att(td_file, tl_att)
+      CALL file_move_att(td_file, tl_att)
 
       tl_att=att_init( "DOMAIN_size_global", (/il_iglo, il_jglo/))
-      CALL file_add_att(td_file, tl_att)
+      CALL file_move_att(td_file, tl_att)
 
       ! allocate local variable
@@ -480,6 +468,6 @@
       IF(il_status /= 0 )THEN
 
-         CALL logger_error( " GET MPP: not enough space to put domain &
-         &  decomposition in file "//TRIM(td_file%c_name) )
+         CALL logger_error( " IOM RSTDIMG GET MPP: not enough space to put "//&
+         &  "domain decomposition in file "//TRIM(td_file%c_name) )
 
       ENDIF
@@ -500,39 +488,44 @@
       CALL fct_err(il_status)
       IF( il_status /= 0 )THEN
-         CALL logger_error("GET INFO: read domain decomposition on first &
-         &              line of "//TRIM(td_file%c_name))
+         CALL logger_debug(" IOM RSTDIMG GET MPP: read status: "//&
+         &  TRIM(fct_str(il_status)))
+         CALL logger_fatal("IOM RSTDIMG GET MPP: read domain decomposition "//&
+         &           "on first line of "//TRIM(td_file%c_name))
       ENDIF
 
       tl_att=att_init( "DOMAIN_position_first", (/il_impp(il_area), il_jmpp(il_area)/))
-      CALL file_add_att(td_file, tl_att)
+      CALL file_move_att(td_file, tl_att)
 
       tl_att=att_init( "DOMAIN_position_last", (/il_lci(il_area), il_lcj(il_area)/))
-      CALL file_add_att(td_file, tl_att)
+      CALL file_move_att(td_file, tl_att)
 
       tl_att=att_init( "DOMAIN_halo_size_start", (/il_ldi(il_area), il_ldj(il_area)/))
-      CALL file_add_att(td_file, tl_att)
+      CALL file_move_att(td_file, tl_att)
 
       tl_att=att_init( "DOMAIN_halo_size_end", (/il_lei(il_area), il_lej(il_area)/))
-      CALL file_add_att(td_file, tl_att)
+      CALL file_move_att(td_file, tl_att)
 
       tl_att=att_init( "DOMAIN_I_position_first", il_impp(:) )
-      CALL file_add_att(td_file, tl_att)
+      CALL file_move_att(td_file, tl_att)
       tl_att=att_init( "DOMAIN_J_position_first", il_jmpp(:) )
-      CALL file_add_att(td_file, tl_att)
+      CALL file_move_att(td_file, tl_att)
 
       tl_att=att_init( "DOMAIN_I_position_last", il_lci(:) )
-      CALL file_add_att(td_file, tl_att)
+      CALL file_move_att(td_file, tl_att)
       tl_att=att_init( "DOMAIN_J_position_last", il_lcj(:) )
-      CALL file_add_att(td_file, tl_att)
+      CALL file_move_att(td_file, tl_att)
 
       tl_att=att_init( "DOMAIN_I_halo_size_start", il_ldi(:) )
-      CALL file_add_att(td_file, tl_att)
+      CALL file_move_att(td_file, tl_att)
       tl_att=att_init( "DOMAIN_J_halo_size_start", il_ldj(:) )
-      CALL file_add_att(td_file, tl_att)
+      CALL file_move_att(td_file, tl_att)
 
       tl_att=att_init( "DOMAIN_I_halo_size_end", il_lei(:) )
-      CALL file_add_att(td_file, tl_att)
+      CALL file_move_att(td_file, tl_att)
       tl_att=att_init( "DOMAIN_J_halo_size_end", il_lej(:) )
-      CALL file_add_att(td_file, tl_att)
+      CALL file_move_att(td_file, tl_att)
+
+      ! clean
+      CALL att_clean(tl_att)
 
       DEALLOCATE( il_impp, il_jmpp,&
@@ -542,18 +535,17 @@
 
    END SUBROUTINE iom_rstdimg_get_mpp
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine read information about variable on an 
-   !> opened dimg file.<br/>
-   !> The variable structure inside file structure is then completed.
+   !> opened dimg file.
+   !> @details
+   !> The variables structures inside file structure are then completed.
+   !> Variables no0d, no1d, no2d, no3d are deleted from file strucutre.
    !> @note variable value are read only for scalar variable (0d).
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @return file structure completed 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !-------------------------------------------------------------------
    SUBROUTINE iom_rstdimg__get_file_var(td_file)
       IMPLICIT NONE
@@ -562,5 +554,5 @@
 
       ! local variable
-      CHARACTER(LEN=ip_vnl), DIMENSION(:), ALLOCATABLE :: cl_name
+      CHARACTER(LEN=im_vnl), DIMENSION(:), ALLOCATABLE :: cl_name
 
       REAL(dp)             , DIMENSION(:), ALLOCATABLE :: dl_value
@@ -605,4 +597,5 @@
 
          IF(ASSOCIATED(td_file%t_var))THEN
+            CALL var_clean(td_file%t_var(:))
             DEALLOCATE(td_file%t_var)
          ENDIF
@@ -638,23 +631,20 @@
 
    END SUBROUTINE iom_rstdimg__get_file_var
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine put information about scalar variable 
+   !-------------------------------------------------------------------
+   !> @brief This subroutine put informations about scalar variable 
    !> inside file structure.
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @param[in] cd_name : table of variable name
-   !> @param[in] dd_value : table of variable value
-   !> @return file structure completed 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !> @param[in] cd_name      array of variable name
+   !> @param[in] dd_value     array of variable value
+   !-------------------------------------------------------------------
    SUBROUTINE iom_rstdimg__get_file_var_0d(td_file, cd_name, dd_value)
       IMPLICIT NONE
       ! Argument      
       TYPE(TFILE),                         INTENT(INOUT) :: td_file
-      CHARACTER(LEN=ip_vnl), DIMENSION(:), INTENT(IN)    :: cd_name
+      CHARACTER(LEN=im_vnl), DIMENSION(:), INTENT(IN)    :: cd_name
       REAL(dp),              DIMENSION(:), INTENT(IN)    :: dd_value
 
@@ -667,5 +657,5 @@
 
       ! define same dimension as in file
-      tl_dim(:)=td_file%t_dim(:)
+      tl_dim(:)=dim_copy(td_file%t_dim(:))
       ! do not use any dimension
       tl_dim(:)%l_use=.FALSE.
@@ -676,5 +666,6 @@
    
          td_file%t_var(ji)=var_init( TRIM(cd_name(ji)), NF90_DOUBLE, &
-         &                           tl_dim(:), id_id=ji, id_rec=1 )
+         &                           tl_dim(:), dd_fill=0._dp,       &
+         &                           id_id=ji, id_rec=1 )
 
          ! get value of scalar
@@ -688,24 +679,24 @@
       ENDDO
 
+      ! clean
+      CALL dim_clean(tl_dim(:))
+
    END SUBROUTINE iom_rstdimg__get_file_var_0d
-   !> @endcode   
-   !-------------------------------------------------------------------
-   !> @brief This subroutine put information about variable 1D 
+   !-------------------------------------------------------------------
+   !> @brief This subroutine put informations about variable 1D 
    !> inside file structure.
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @param[in] cd_name : table of variable name
-   !> @param[in] dd_value : table of variable record
-   !> @return file structure completed 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !> @param[in] cd_name      array of variable name
+   !> @param[in] dd_value     array of variable record
+   !-------------------------------------------------------------------
    SUBROUTINE iom_rstdimg__get_file_var_1d(td_file, cd_name, dd_value)
       IMPLICIT NONE
       ! Argument      
       TYPE(TFILE),                         INTENT(INOUT) :: td_file
-      CHARACTER(LEN=ip_vnl), DIMENSION(:), INTENT(IN)    :: cd_name
+      CHARACTER(LEN=im_vnl), DIMENSION(:), INTENT(IN)    :: cd_name
       REAL(dp),              DIMENSION(:), INTENT(IN)    :: dd_value
 
@@ -722,5 +713,5 @@
 
          ! define same dimension as in file
-         tl_dim(:)=td_file%t_dim(:)
+         tl_dim(:)=dim_copy(td_file%t_dim(:))
          ! do not use X and Y dimension
          td_file%t_var(ji)%t_dim(1:2)%l_use=.FALSE.
@@ -728,29 +719,29 @@
       
          td_file%t_var(ji)=var_init( TRIM(cd_name(ji)), NF90_DOUBLE, &
-         &                           tl_dim(:), id_id=ji,            &
-         &                           id_rec=INT(dd_value(ji),i4) )
+         &                           tl_dim(:), dd_fill=0._dp,       &
+         &                           id_id=ji, id_rec=INT(dd_value(ji),i4) )
+
+         ! clean
+         CALL dim_clean(tl_dim(:))
 
       ENDDO
 
    END SUBROUTINE iom_rstdimg__get_file_var_1d
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine put information about variable 2D 
+   !-------------------------------------------------------------------
+   !> @brief This subroutine put informations about variable 2D 
    !> inside file structure.
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @param[in] cd_name : table of variable name
-   !> @param[in] dd_value : table of variable record
-   !> @return file structure completed 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !> @param[in] cd_name      array of variable name
+   !> @param[in] dd_value     array of variable record
+   !-------------------------------------------------------------------
    SUBROUTINE iom_rstdimg__get_file_var_2d(td_file, cd_name, dd_value)
       IMPLICIT NONE
       ! Argument      
       TYPE(TFILE),                         INTENT(INOUT) :: td_file
-      CHARACTER(LEN=ip_vnl), DIMENSION(:), INTENT(IN)    :: cd_name
+      CHARACTER(LEN=im_vnl), DIMENSION(:), INTENT(IN)    :: cd_name
       REAL(dp),              DIMENSION(:), INTENT(IN)    :: dd_value
 
@@ -767,5 +758,5 @@
 
          ! define same dimension as in file
-         tl_dim(:)=td_file%t_dim(:)
+         tl_dim(:)=dim_copy(td_file%t_dim(:))
          ! do not use Z dimension
          tl_dim(3)%l_use=.FALSE.
@@ -773,29 +764,29 @@
 
          td_file%t_var(ji)=var_init( TRIM(cd_name(ji)), NF90_DOUBLE, &
-         &                           tl_dim(:), id_id=ji,            &
-         &                           id_rec=INT(dd_value(ji),i4) )
+         &                           tl_dim(:), dd_fill=0._dp,       &
+         &                           id_id=ji, id_rec=INT(dd_value(ji),i4) )
+
+         ! clean
+         CALL dim_clean(tl_dim(:))
 
       ENDDO
 
    END SUBROUTINE iom_rstdimg__get_file_var_2d
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine put information about variable 3D 
+   !-------------------------------------------------------------------
+   !> @brief This subroutine put informations about variable 3D 
    !> inside file structure.
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @param[in] cd_name : table of variable name
-   !> @param[in] dd_value : table of variable record
-   !> @return file structure completed 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !> @param[in] cd_name      array of variable name
+   !> @param[in] dd_value     array of variable record
+   !-------------------------------------------------------------------
    SUBROUTINE iom_rstdimg__get_file_var_3d(td_file, cd_name, dd_value)
       IMPLICIT NONE
       ! Argument      
       TYPE(TFILE),                         INTENT(INOUT) :: td_file
-      CHARACTER(LEN=ip_vnl), DIMENSION(:), INTENT(IN)    :: cd_name
+      CHARACTER(LEN=im_vnl), DIMENSION(:), INTENT(IN)    :: cd_name
       REAL(dp),              DIMENSION(:), INTENT(IN)    :: dd_value
 
@@ -812,14 +803,16 @@
 
          ! define same dimension as in file
-         tl_dim(:)=td_file%t_dim(:) 
+         tl_dim(:)=dim_copy(td_file%t_dim(:)) 
 
          td_file%t_var(ji)=var_init( TRIM(cd_name(ji)), NF90_DOUBLE, &
-         &                           tl_dim(:), id_id=ji,            &
-         &                           id_rec=INT(dd_value(ji),i4) )
+         &                           tl_dim(:), dd_fill=0._dp,       &
+         &                           id_id=ji, id_rec=INT(dd_value(ji),i4) )
+
+         ! clean
+         CALL dim_clean(tl_dim(:))
 
       ENDDO
 
    END SUBROUTINE iom_rstdimg__get_file_var_3d
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This function read one dimension in an opened netcdf file, 
@@ -829,9 +822,8 @@
    !> - Nov, 2013- Initial Version
    !
-   !> @param[in] td_file : file structure
-   !> @param[in] id_dimid : dimension id
+   !> @param[in] td_file   file structure
+   !> @param[in] id_dimid  dimension id
    !> @return  dimension structure 
    !-------------------------------------------------------------------
-   !> @code
    TYPE(TDIM) FUNCTION iom_rstdimg__read_dim_id(td_file, id_dimid)
       IMPLICIT NONE
@@ -866,5 +858,4 @@
 
    END FUNCTION iom_rstdimg__read_dim_id
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This function read one dimension in an opened netcdf file, 
@@ -874,9 +865,8 @@
    !> - Nov, 2013- Initial Version
    !
-   !> @param[in] td_file : file structure
-   !> @param[in] cd_name : dimension name
+   !> @param[in] td_file   file structure
+   !> @param[in] cd_name   dimension name
    !> @return  dimension structure 
    !-------------------------------------------------------------------
-   !> @code
    TYPE(TDIM) FUNCTION iom_rstdimg__read_dim_name(td_file, cd_name)
       IMPLICIT NONE
@@ -909,22 +899,21 @@
 
    END FUNCTION iom_rstdimg__read_dim_name
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This function read variable value in an opened 
-   !> dimg file, given variable id.</br/>
-   !> start indices and number of indices selected along each dimension 
-   !> could be specify in a 4 dimension table (/'x','y','z','t'/)
+   !> dimg file, given variable id.
+   !> @details
+   !> Optionaly, start indices and number of indices selected along each dimension 
+   !> could be specify in a 4 dimension array (/'x','y','z','t'/)
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !> @param[in] id_varid : variable id
-   !> @param[in] id_start : index in the variable from which the data values 
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_file   file structure
+   !> @param[in] id_varid  variable id
+   !> @param[in] id_start  index in the variable from which the data values 
    !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
+   !> @param[in] id_count  number of indices selected along each dimension
    !> @return  variable structure 
    !-------------------------------------------------------------------
-   !> @code
    TYPE(TVAR) FUNCTION iom_rstdimg__read_var_id(td_file, id_varid,&
    &                                            id_start, id_count)
@@ -935,9 +924,7 @@
       INTEGER(i4), DIMENSION(:), INTENT(IN), OPTIONAL :: id_start
       INTEGER(i4), DIMENSION(:), INTENT(IN), OPTIONAL :: id_count
-      !INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN), OPTIONAL :: id_start
-      !INTEGER(i4), DIMENSION(ip_maxdim), INTENT(IN), OPTIONAL :: id_count
 
       ! local variable
-      INTEGER(i4), DIMENSION(1) :: il_ind
+      INTEGER(i4), DIMENSION(1) :: il_varid
       !----------------------------------------------------------------
       ! check if file opened
